# Copyright (c) 2006, Brian Frank, Andy Frank, and John Sublett.
# Licensed under BSD, see http://www.fandev.org/license.txt for terms.

#
# preftest 
#
# @author   Brian Frank
# @creation 23 Oct 06
#

require 'adm/env.rb'

class PerfTest < Env

  def main()

  t1 = Time.new
  
  # compile sysTest with Java
  syscall("fanc #@fan_src/sysTest")  
  t2 = Time.new
  
  # compile compiler with Java
  syscall("fanc #@fan_src/compiler")  
  t3 = Time.new

  # run sysTest three times
  syscall("fant sysTest")  
  t4 = Time.new
  syscall("fant sysTest")  
  t5 = Time.new
  syscall("fant sysTest")  
  t6 = Time.new
  
  # compile sysTest with Fan by Java
  syscall("ffanc /dev/fan/src/sysTest/")  
  t7 = Time.new

  # run sysTest three times
  syscall("fant sysTest")  
  t8 = Time.new
  syscall("fant sysTest")  
  t9 = Time.new
  syscall("fant sysTest")  
  tA = Time.new
  
  # compile compiler with Fan
  syscall("ffanc -d /dev/fan/tmp/ /dev/fan/src/compiler/")  
  tB = Time.new
  syscall("copy \\dev\\fan\\tmp\\compiler.pod \\dev\\fan\\lib\\fan\\compiler.pod /y")  
  tC = Time.new
  
  # compile sysTest with Fan by Fan
  syscall("ffanc /dev/fan/src/sysTest/")  
  tD = Time.new
  
  puts("")
  puts("")
  puts("Compile sysTest:")
  puts("  Java Compiler         = " + (t2-t1).to_s + "sec")
  puts("  Fan  Compiler by Java = " + (t7-t6).to_s + "sec")
  puts("  Fan  Compiler by Fan  = " + (tD-tC).to_s + "sec")
  puts("")
  puts("Java sysTest  =  " + (t4-t3).to_s + "sec")
  puts("              =  " + (t5-t4).to_s + "sec")
  puts("              =  " + (t6-t5).to_s + "sec")
  puts("              => " + (((t4-t3) + (t5-t4) + (t6-t5))/3).to_s + "sec")
  puts("")
  puts("Fan sysTest   =  " + (t8-t7).to_s + "sec")
  puts("              =  " + (t9-t8).to_s + "sec")
  puts("              =  " + (tA-t9).to_s + "sec")
  puts("              => " + (((t8-t7) + (t9-t8) + (tA-t9))/3).to_s + "sec")

  end
  
end

# script
PerfTest.new.main