class StubSys
{

  static Void stub(Type t)
  {
    name := t.name
    f := dir + "${name}.cs".toUri
    echo("Stub: $f")
    out := f.create.out

    out.print("/* Copyright */\n")
    out.print("\n")
    out.print("namespace Fan.Sys\n")
    out.print("{\n")
    out.print("\n")
    out.print("  public class $name\n")
    out.print("  {\n")
    methods := t.methods.findAll |->Bool| { return true } // hack for dup
    methods.sort |Method a, Method b->Int| { return b.isCtor <=> a.isCtor }
    methods.each |Method m|
    {
      if (m.parent == t)
        stubMethod(out, m)
    }
    out.print("  }\n")
    out.print("\n")
    out.print("}\n")
    out.close
  }

  static Void stubMethod(OutStream out, Method m)
  {
    out.print("\n")
    out.print("    ")
    if (m.isAbstract) out.print("abstract ")
    if (m.isStatic || m.isCtor) out.print("static ")
    if (m.isVirtual) out.print("virtual ")
    if (m.isOverride) out.print("override ")
    out.print("${t(m.returnType)} ${m.name}(")
    out.print(m.params.join(", ") |MethodParam p->Str|
    {
      s := t(p.paramType) + " " + p.name
      return s
    })
    out.print(")")
    if (m.isAbstract) { out.print(";\n"); return }
    out.print("\n")
    out.print("    {\n")
    out.print("      // TODO\n")
    if (m.returnType.name != "Void") out.print("      return null;\n")
    out.print("    }\n")
  }

  static Str t(Type t)
  {
    if (t.name == "Void") return "void"
    if (t.signature.endsWith("[]")) return "List"
    if (t.signature.startsWith("[")) return "Map"
    if (t.signature.startsWith("|")) return "Method"
    if (t.name.size == 1)
    {
      if (t.name == "L") return "List";
      if (t.name == "M") return "Map";
      return "Obj";
    }
    return t.name
  }

  static Void main()
  {
    dir.create
    Sys.findPod("sys").types.each |Type t| { stub(t) }
  }

  static File dir := File.make(`/dev/fan/src/nfan/stub/`)
}