@echo off
rem
rem build.bat
rem
rem   This batch file builds the launcher executables for Win32.
rem   You will need to install the C++ compiler and Platform SDK, we
rem   assume the PlatformSDK include and libs are available under
rem   the VC directory:
rem     http://forums.microsoft.com/MSDN/ShowPost.aspx?PostID=7004&SiteID=1
rem
rem   Environment variables which must be passed in:
rem      VCINSTALLDIR - Microsoft Visual Studio C++ (use vcvars32.bat)
rem      fan_home     - home directory of Fan installation
rem      java_home    - home directory of installed JDK
rem

rem sdk is the Windows PlatformSDK dir (we assume installed under VC)
set sdk=%VCINSTALLDIR%\PlatformSDK

rem compiler setup
set includes=/I"%sdk%\Include" /I"%java_home%\include" /I"%java_home%\include\win32"
set libs="%sdk%\Lib\uuid.lib" "%sdk%\Lib\advapi32.lib" "%sdk%\Lib\mscoree.lib" "%sdk%\Lib\user32.lib" "%sdk%\Lib\oleaut32.lib" "%sdk%\Lib\ole32.lib"
set defs=/D_CRT_SECURE_NO_DEPRECATE
set compile=cl %defs% %includes% launcher.cpp props.cpp java.cpp net.cpp utils.cpp %libs%

rem compile each executable
%compile% /DFAN_MAIN="\"Fan\""   /Fe%fan_home%\bin\win\fan.exe
%compile% /DFAN_MAIN="\"Fant\""  /Fe%fan_home%\bin\win\fant.exe
%compile% /DFAN_MAIN="\"Fanp\""  /Fe%fan_home%\bin\win\fanp.exe
%compile% /DFAN_MAIN="\"Jstub\"" /Fe%fan_home%\bin\win\jstub.exe
%compile% /DFAN_MAIN="\"Nstub\"" /Fe%fan_home%\bin\win\nstub.exe
%compile% /DFAN_MAIN="\"Fand\""  /Fe%fan_home%\bin\win\fand.exe
%compile% /DFAN_MAIN="\"Fansh\"" /Fe%fan_home%\bin\win\fansh.exe

rem cleanup
del *.obj
del *.tlh

echo
echo **
echo ** SUCCESS!
echo **