//
// Copyright (c) 2007, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   21 Dec 07  John Sublett   Creation
//

**
** Statement manages a statement prepared for a database
** connection.
**
** Refer to the [Sql docs]`docLib::Sql` for more details.
**
class Statement
{
  **
  ** Make a new statement with the specified SQL text.
  **
  internal new make(Connection conn, Str sql)
  {
    this.conn = conn
    this.sql = sql
  }

  **
  ** Prepare this statement for use with the specified
  ** connection.
  **  
  internal native Statement prepare()
  
  **
  ** Execute the statement and get a relational table as the result.
  ** If 'of' is 'null', the result is returned as a 'List'
  ** of 'Rows'.  The 'Cols' are available from 'List.of.fields' or
  ** on 'type.fields' of each row instance.  If 'of' is specified,
  ** then the result is returned as a 'List' of that type.  Columns
  ** are mapped to the type's fields.  If a column cannot be mapped
  ** to a field, then an 'SqlErr' is thrown.
  **
  native Obj[] query(Str:Obj params, Type of := null)
  
  native Void queryEach(Str:Obj params, Type of, |Obj row| eachFunc)
  
  **
  ** Execute a SQL statement and if applicable return
  ** the number of rows modified.
  **
  native Int execute(Str:Obj params)

  **
  ** Close the statement.
  **
  native Void close()

///////////////////////////////////////////////////////////
// Fields
///////////////////////////////////////////////////////////

  **
  ** The connection that this statement uses.
  **
  readonly Connection conn
  
  **
  ** The SQL text used to create this statement.
  **
  readonly Str sql
}