//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

**
** Test the DbModel class.
**
class DbModelTest : Test
{
  Void test()
  {
    build
    missingDepends
    
  }
  
  Void build()
  {
    model := DbModel.make
    model.addType(sql::Chapter.type)
    model.addType(sql::Book.type)
    model.addType(sql::Person.type)
    model.addType(sql::Publisher.type)
    model.commit
    
    createOrder := model.listTypes
    verifyEq(createOrder[0], sql::Person.type)
    verifyEq(createOrder[1], sql::Publisher.type)
    verifyEq(createOrder[2], sql::Book.type)
    verifyEq(createOrder[3], sql::Chapter.type)
  }
  
  Void missingDepends()
  {
    model := DbModel.make
    model.addType(sql::Chapter.type)
    model.addType(sql::Person.type)
    model.addType(sql::Publisher.type)

    try
    {    
      model.commit
    }
    catch(Err e)
    {
      verify(e.type == SqlErr.type)
      verify(e.message.startsWith("Missing dependency"), "Incorrect error: $e.message")
    }
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  DbModel model

}