//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   29 Nov 07  Brian Frank  Creation
//

**
** ResourceTest tests TableResource and O/R mapping
**
class ResourceTest : Test
{

  //
  // TODO: need to refactor SqlTest so that all tests
  // share same connection/database setup and tear down
  //

  Void test()
  {
    // verify new unmounted
    t := TableResource.make(`/farmers`)
    verifyEq(t.uri, `/farmers`)
    verifyEq(t.name, "farmers")
    verifyEq(t.obj, null)
    verifyEq(t.list, Resource[,])
    verifyErr(UnsupportedErr.type) |,| { t.refresh }
    verifyErr(UnsupportedErr.type) |,| { t.delete }

    // mount, verify original working updated
    t.create
    verifyEq(t.uri, `/farmers`)
    verifyEq(t.name, "farmers")
    verifyEq(t.obj, null)
    verifyEq(t.list, Resource[,])

    // resolve, verify new working
    x := `/farmers`.resolve
    verifyEq(x.type, TableResource.type)
    verifyNotSame(t, x)
    verify(x is TableResource)
    t = x as TableResource
    verifyEq(t.uri, `/farmers`)
    verifyEq(t.name, "farmers")
    verifyEq(t.obj, null)
    verifyEq(t.list, Resource[,])

    // delete, verify gone
    t.delete
    verifyEq(`/farmers`.resolve(null, false), null)
    verifyErr(UnresolvedErr.type) |,| { `/farmers`.resolve }

    // TODO:
    //   - add rows
    //   - resolve row Uris
    //   - list rows
    //   - delete rows
  }

}
