//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

**
** Test behavior of the TypeGraph.
**
class TypeGraphTest : Test
{
  Void test()
  {
    sort
    cycle
  }
  
  Void sort()
  {
    graph := TypeGraph.make
    graph.addDependency(sql::Book.type, sql::Person.type)
    graph.addDependency(sql::Book.type, sql::Publisher.type)
    graph.addDependency(sql::Chapter.type, sql::Book.type)
    
    types := graph.sort
    verifyEq(types[0], sql::Person.type)
    verifyEq(types[1], sql::Publisher.type)
    verifyEq(types[2], sql::Book.type)
    verifyEq(types[3], sql::Chapter.type)
  }
  
  Void cycle()
  {
    graph := TypeGraph.make
    graph.addDependency(sql::Book.type, sql::Person.type)
    graph.addDependency(sql::Person.type, sql::Book.type)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }
    
    graph = TypeGraph.make
    graph.addDependency(sql::Book.type, sql::Person.type)
    graph.addDependency(sql::Person.type, sql::Chapter.type)
    graph.addDependency(sql::Chapter.type, sql::Book.type)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }
  }
}