//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   24 Nov 07  Brian Frank  Creation
//

**
** MemResource is a memory based resource which wraps
** an immutable or serialized obj.  A MemResource can
** also contain other MemResources.
**
class MemResource : Resource
{

  **
  ** Make a memory based resource which wraps the specified obj.
  ** The object must be either immutable or serializable.  This
  ** method doesn't `create` the resource, rather it just returns
  ** an unmounted wrapper Resource.
  **
  new make(Uri uri, Obj obj)

  // subclasses cannot override
  override final Obj obj

}
