//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   31 Jul 07  Andy Frank  Creation
//

**
** Widget defines a reuable snippet of HTML.
**
abstract class Widget
{

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////

  new make()
  {
    req  = (WebReq)Thread.locals["web.req"]
    res  = (WebRes)Thread.locals["web.res"]
  }

//////////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////////

  **
  ** Render the markup for this widget. This method *must*
  ** use the `head` and `body` fields for rendering the
  ** markup in order to produce a valid HTML file.  Never
  ** use 'res.out' directly.
  **
  abstract Void render()

  **
  ** Handle a form submission.
  **
  virtual Void submit()
  {
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  **
  ** The WebReq instance for this request.
  **
  readonly WebReq req

  **
  ** The WebRes instance for this request.
  **
  readonly WebRes res

  **
  ** The buffered WebOutStream for the <head> element.
  **
  readonly WebOutStream head
  {
    get
    {
      if (@head == null)
        @head = (WebOutStream)Thread.locals["web.widget.head"]
      return @head
    }
  }

  **
  ** The buffered WebOutStream for the <body> element.
  **
  readonly WebOutStream body
  {
    get
    {
      if (@body== null)
        @body = (WebOutStream)Thread.locals["web.widget.body"]
      return @body
    }
  }

}