//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   23 Dec 07  Brian Frank  Creation
//

using web

**
** DefaultPage is a standard run-of-the-mill page implementation.
**
class DefaultPage : Page
{

  override Void render()
  {
    // header
    headElem.w(
    "<title>$req.uri</title>
     <style type='text/css'>
        table { border-collapse: collapse; border: 1px solid #d0dae5; }
        th, tr { border: 1px solid #d0dae5; text-align: left; padding: 3px; }
        .thbar { background: #e2e6e8; }
        .nav  { background: #f2f6f8; margin-bottom: 10px; padding: 5px; border: 1px solid #d0dae5; }
     </style>")

    // breadcrumb
    bodyElem.w("<div class='nav'>")
    bodyElem.w("<a href='/'>Home</a>")
    path := req.uri.path
    if (path != null)
    {
      path.size.times |Int i|
      {
        sub := "/" + path[0..i].join("/")
        bodyElem.w(" | <a href='${sub}'>${path[i]}</a>")
      }
    }
    bodyElem.w("</div>")

    // main view
    DefaultView.make.render
  }

}