//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Jun 07  Brian Frank  Creation
//

using web

**
** WispReq
**
class WispReq : WebReq
{
  new make(WispService service, InStream in)
  {
    this.service = service
    this.in = in
  }

  override WispService service
  override Str method
  override Version version
  override Uri suffixUri
  override Uri prefixUri
  override Str:Str headers
  override UserAgent userAgent
  override Uri uri
  override Str:Obj stash := Str:Obj[:]
  override InStream in

  override Str:Str form
  {
    get
    {
      if (@form == null && headers["Content-Type"] == "application/x-www-form-urlencoded")
      {
        len := headers["Content-Length"]
        if (len == null) throw IOErr.make("Missing Content-Length header")
        @form = Uri.decodeQuery(in.readLine(len.toInt))
      }
      return @form
    }
  }
}